/*
 File: parallel_opersym.cpp
 Date and Time: Fri Jan 30 18:55:18 2015 
*/
#include "parallel_oper.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_parallel_oper;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_parallel_oper::TH_parallel_oper(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_parallel_oper;
  NS_parallel_oper::Cparallel_oper Cparallel_oper_;// parallel-parser's parse table
#define ssPARSE_TABLE Cparallel_oper_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_parallel_oper::PROC_TH_parallel_oper(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_parallel_oper";
  static bool one_time(false);
  static NS_parallel_oper::Cparallel_oper* NS_parallel_oper_Cparallel_oper_(0);// parallel-parser's fsm table
  static Parser* NS_parallel_oper_Cparallel_oper_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_parallel_oper_Cparallel_oper_ = new NS_parallel_oper::Cparallel_oper();// parallel-parser's fsm table
    NS_parallel_oper_Cparallel_oper_parser = new Parser(*NS_parallel_oper_Cparallel_oper_,Caller_pp);
  }
 proc_parser = NS_parallel_oper_Cparallel_oper_parser;
#include "wproc_pp_core.h"
}
void 
Cparallel_oper::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rparallel_oper_:{
       Rparallel_oper* sym;
     if(re->rule_ == 0){
       sym = new Rparallel_oper(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rparallel_oper*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     sym->sr1();
     sym->op();
     return;}
    case rhs2_Rparallel_oper_:{
       Rparallel_oper* sym;
     if(re->rule_ == 0){
       sym = new Rparallel_oper(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rparallel_oper*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 5;
    

     sym->sr2();
     sym->op();
     return;}
    case rhs3_Rparallel_oper_:{
       Rparallel_oper* sym;
     if(re->rule_ == 0){
       sym = new Rparallel_oper(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rparallel_oper*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     sym->sr3();
     sym->op();
     return;}
    case rhs4_Rparallel_oper_:{
       Rparallel_oper* sym;
     if(re->rule_ == 0){
       sym = new Rparallel_oper(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rparallel_oper*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 5;
    

     sym->sr4();
     sym->op();
     return;}
    default: return;
   }
}
